-- added by eric.xiang for SDNA in 2013-1-5
-- use "YunFeng"'s code for object orientate method for lua
local print,assert=print,assert
local setmetatable=setmetatable
local table,ipairs,pairs=table,ipairs,pairs
local Deb=Deb
module("scripts.util.oo")

local _class={}
local _inf={}
local _infsuper={}
local _classNo=0
--if _class == nil then _class={} end
if classCount==nil then classCount=0 end


function classes(super,name)
--	Deb("calling create class "..(name or ""))
	_classNo=_classNo+1
	if super then
		 -- 保存继承链信息
		_inf[name]=super.typeName
		_infsuper[super.typeName]=true	
	else
		_inf[name]="nil"
	end

	local class_type={}
	class_type.typeName=name
	class_type.ctor=false
	class_type.super=super
	class_type.new=function(...) 
			local obj={}
			do
				local create
				create = function(c,...)
					if c.super then
						create(c.super,...)
					end
					if c.ctor then
						c.ctor(obj,...)
					end
				end
 
				create(class_type,...)
			end
			setmetatable(obj,{ __index=_class[class_type] })
			return obj
		end
	local vtbl={}
	assert(_class[class_type]==nil)
	_class[class_type]=vtbl
	
 	classCount=classCount+1
 		
	setmetatable(class_type,{__newindex=
		function(t,k,v)
			vtbl[k]=v
		end
	})
 
	if super then
		setmetatable(vtbl,{__index=
			function(t,k)
				local s = _class[super]
				assert(s,super)
				local ret=s[k]
				vtbl[k]=ret
				return ret
			end
		})
	end
 
	return class_type
end

class_object=classes

function afterClassCreate()
	Deb("------------------------classes init---------------------------------------")
	local icn=0
	for k,v in pairs(_inf) do
		if not _infsuper[k] then -- 如果这个key为顶级子类
			icn=icn+1
			local name = k
			local str="["..name.."]"
			while(name ~= nil and name~="nil")
			do
				name = _inf[name]
				if name and name~= "nil" then str=str.."->"..name end
			end
			Deb(str)
		end
	end	
	Deb("create [".._classNo.."] classes, include ["..icn.."] instance classes")
	Deb("------------------------classes done---------------------------------------")
end

--创建对象
--function new( object )
--	if not object then
--		return nil
--	end
--	o = {}
--	setmetatable(o, object)
--	object.__index = object
--	return o
--end

--local function search (k, plist)
--    for i=1, table.getn(plist) do
--       local v = plist[i][k]    -- try 'i'-th superclass
--       if v then return v end
--    end
--end
-- 
---- 多重继承
--function newClass(...)
--    local c = {}      -- new class
--
--    -- class will search for each method in the list of its
--    -- parents (`arg' is the list of parents)
--    setmetatable(c, {__index = function (t, k)
--    return search(k, arg)
--	end})
--
--	-- prepare `c' to be the metatable of its instances
--	c.__index = c
--
--	-- define a new constructor for this new class
--	function c:new (o)
--		o = o or {}
--		setmetatable(o, c)
--		print("------------------------")
--		printTable(o)
--		print("------------------------")
--		return o
--	end
--	-- return new class
--    return c
--end